#include "BinSolver.h"
#include "global.h"

#include "model.h"

#include<stdio.h>
#include<string.h>

// solver order: 
//		0:minisat20
//		1:zchaff_rand
// 		2:vallst
//		3:march_dl
//		4:kcnfs

BinSolver* binSolvers[10];
BinSolver* LSSolver;
int NUM_ALGS = 7;

void BuildSolvers(char* strseed)
{
// -- eureka
  binSolvers[0]=new BinSolver ("eureka", 2, 1);
  binSolvers[0]->argv[2] = NULL;
 binSolvers[0]->models = new SATmodel(eurekaSModel, eurekaUModel, eurekaFeatMean, eurekaFeatStd, eurekaFeatID1, eurekaFeatID2, eurekaClassCoeffS, eurekaClassCoeffU, eurekaNumFeat);

 
  // -- march_dl 2004
  binSolvers[1]=new BinSolver ("marchdl04", 2, 1);
  binSolvers[1]->argv[2] = NULL;
 binSolvers[1]->models = new SATmodel(marchdl04SModel, marchdl04UModel, marchdl04FeatMean, marchdl04FeatStd, marchdl04FeatID1, marchdl04FeatID2, marchdl04ClassCoeffS, marchdl04ClassCoeffU, marchdl04NumFeat);

// -- minisat2.0
  binSolvers[2]=new BinSolver ("minisat20", 3, 1);
  binSolvers[2]->argv[2] = "foo";
  binSolvers[2]->argv[3] = NULL;

  binSolvers[2]->models = new SATmodel(minisat20SModel, minisat20UModel, minisat20FeatMean, minisat20FeatStd, minisat20FeatID1, minisat20FeatID2, minisat20ClassCoeffS, minisat20ClassCoeffU, minisat20NumFeat);


// -- tts40
  binSolvers[3]=new BinSolver ("tts40", 2, 1);
  binSolvers[3]->argv[2] = NULL;
 binSolvers[3]->models = new SATmodel(tts40SModel, tts40UModel, tts40FeatMean, tts40FeatStd, tts40FeatID1, tts40FeatID2, tts40ClassCoeffS, tts40ClassCoeffU, tts40NumFeat);

 
// -- picosat
  binSolvers[4]=new BinSolver ("picosat", 2, 1);
  binSolvers[4]->argv[2] = NULL;
 binSolvers[4]->models = new SATmodel(picosatSModel, picosatUModel, picosatFeatMean, picosatFeatStd, picosatFeatID1, picosatFeatID2, picosatClassCoeffS, picosatClassCoeffU, picosatNumFeat);

// -- mxc
  binSolvers[5]=new BinSolver ("mxc", 2, 1);
  binSolvers[5]->argv[2] = NULL;
 binSolvers[5]->models = new SATmodel(mxcSModel, mxcUModel, mxcFeatMean, mxcFeatStd, mxcFeatID1, mxcFeatID2, mxcClassCoeffS, mxcClassCoeffU, mxcNumFeat);

// -- minisat07
  binSolvers[6]=new BinSolver ("minisat07", 2, 1);
  binSolvers[6]->argv[2] = NULL;
 binSolvers[6]->models = new SATmodel(minisat07SModel, minisat07UModel, minisat07FeatMean, minisat07FeatStd, minisat07FeatID1, minisat07FeatID2, minisat07ClassCoeffS, minisat07ClassCoeffU, minisat07NumFeat);




  LSSolver=new BinSolver ("ubcsat2006", 17, 2);
  LSSolver->argv[1] = "-inst";
  LSSolver->argv[3] = "-alg";
  LSSolver->argv[4] = "saps";
  LSSolver->argv[5] = "-alpha";
  LSSolver->argv[6] = "1.3";
  LSSolver->argv[7] = "-rho";
  LSSolver->argv[8] = "0.1";
  LSSolver->argv[9] = "-cutoff";
  LSSolver->argv[10] = "max";
  LSSolver->argv[11] = "-timeout";
  LSSolver->argv[12] = LS_PREP_TIMEOUT;
//  LSSolver->argv[13] = "-solve";
  LSSolver->argv[13] = "-seed";
  LSSolver->argv[14] = strseed;
  LSSolver->argv[15] = "-r";
  LSSolver->argv[16] = "satcomp";
  LSSolver->argv[17] = NULL;  
 

}
int runLocalSearch(char* inputFile, char* strseed)
{
  char* argv[] = {"ubcsat",
                  "-alg", "saps",  "-i", inputFile, "-runs", "1",
                  "-alpha", "1.3", "-rho", "0.1",  "-timeout", LS_PREP_TIMEOUT,
                  "-seed", strseed,
                  "-solve"};
  //		  "-r", "satcomp", vlineFilename,

  int argc = 16;

  printf("c satzilla is running local search for 30s\n");
  return  ubcsat::main(argc, argv);

}
